#include <stdio.h>
#include <math.h> 
#include <stdlib.h> 
#include <string.h>

int i;
int eye,r,g,b,percent;
int rr,gg,bb;

int grid[5],grid2[5];

char plan[2],cube[3];
int orig;

char vertex[126][200];
int num[9],p[9][4];

float kr,kg,kb,k[4];

float P1[4],P2[4],P3[4],P4[4],P5[4],P6[4],out[4],out2[4];

FILE *dolby,*newgrid,*gridout;
char path[200],name[200],fullname[200];

/****************************************************************************/

main()
{

/********************************************************************************/
/*
                                                  (401)
                                                   301     5x5 CUBE
                                                   201
                         CUBE                      101
                      R---------M                  001--002--003--004--005
                      |\        |\                   \ 00 \    \    \    \
                      | \       | \                  006--007--008--009--010
                      |  \      |  \                   \    \ 11 \    \    \
                      |   Y---------White              011--012--013--014--015
                  blacK---|-----B   |                    \    \    \ 22 \    \
                       \  |      \  |                    016--017--018--019--020
                        \ |       \ |                      \    \    \    \ 33 \
                         \|        \|                      021--022--023--024--025
                          G---------C  
*/

newgrid=fopen("newgrid.txt","r"); if(newgrid==NULL){printf("%s : File does not exist\n","newgrid.txt");exit(0);}
	fgets(vertex[1],100,newgrid);
	sscanf(vertex[1],"%d %d %d",&grid2[1],&grid2[2],&grid2[3]); grid2[0]=0; grid2[4]=255;
fclose(newgrid);

gridout=fopen("gridout.txt","w");
	fprintf(gridout,"%.3d %.3d %.3d #GRID\n",grid2[1],grid2[2],grid2[3]);

dolby=fopen("profile.txt","r"); if(dolby==NULL){printf("%s : File does not exist\n","profile.txt");exit(0);}
	fgets(vertex[1],100,dolby);
	sscanf(vertex[1],"%d %d %d",&grid[1],&grid[2],&grid[3]); grid[0]=0; grid[4]=255;

for(eye=1;eye<=2;++eye){
	for(i=1;i<=125;++i)fgets(vertex[i],100,dolby);

for(r=0;r<256;++r){
for(g=0;g<256;++g){
for(b=0;b<256;++b){
/******************************************************ascertain sub-cube********/

if(r>=grid[0]&&r<grid[1])rr=0;		/* n de grid */
if(r>=grid[1]&&r<grid[2])rr=1;
if(r>=grid[2]&&r<grid[3])rr=2;
if(r>=grid[3]&&r<=grid[4])rr=3;

if(g>=grid[0]&&g<grid[1])gg=0;
if(g>=grid[1]&&g<grid[2])gg=1;
if(g>=grid[2]&&g<grid[3])gg=2;
if(g>=grid[3]&&g<=grid[4])gg=3;

if(b>=grid[0]&&b<grid[1])bb=0;
if(b>=grid[1]&&b<grid[2])bb=1;
if(b>=grid[2]&&b<grid[3])bb=2;
if(b>=grid[3]&&b<=grid[4])bb=3;

			if(r!=grid2[0]&&r!=grid2[1]&&r!=grid2[2]&&r!=grid2[3]&&r!=grid2[4])continue;
			if(g!=grid2[0]&&g!=grid2[1]&&g!=grid2[2]&&g!=grid2[3]&&g!=grid2[4])continue;
			if(b!=grid2[0]&&b!=grid2[1]&&b!=grid2[2]&&b!=grid2[3]&&b!=grid2[4])continue;

sprintf(cube,"%d%d",gg,bb);		/* numro cube au sol */
sprintf(plan,"%d",rr);			/* plan */

kr=(float)(r-grid[rr]) / (float)( grid[rr+1]-grid[rr] );	/* real deltas in %   must be < 1 */
kg=(float)(g-grid[gg]) / (float)( grid[gg+1]-grid[gg] );
kb=(float)(b-grid[bb]) / (float)( grid[bb+1]-grid[bb] );

/******************************************************floor origin number*******/
if(atoi(cube)>= 0&&atoi(cube)<10)orig=atoi(cube)+1;
if(atoi(cube)>=10&&atoi(cube)<20)orig=atoi(cube)-4;
if(atoi(cube)>=20&&atoi(cube)<30)orig=atoi(cube)-9;
if(atoi(cube)>=30&&atoi(cube)<40)orig=atoi(cube)-14;
/******************************************************line number in file******/
num[1]=orig+atoi(plan)*25;			/* which floor ? */

		  num[2]=num[1]+1;   num[3]=num[1]+5;   num[4]=num[1]+6;  /* name the other 3 vertices */
num[5]=num[1]+25; num[6]=num[1]+26;  num[7]=num[1]+30;  num[8]=num[1]+31; /* 4 vertices next floor */

/* num[] is in fact line number in input file */

/******************************************************corrected 8 vertex cube**/
for(i=1;i<=8;++i)sscanf(vertex[num[i]],"%d %d %d",&p[i][1],&p[i][2],&p[i][3]);

/******************************************************trilinear interpolation**/
		for(i=1;i<=3;++i){
			P1[i]=p[1][i]+kr*(p[5][i]-p[1][i]);
			P2[i]=p[2][i]+kr*(p[6][i]-p[2][i]);
			P3[i]=p[3][i]+kr*(p[7][i]-p[3][i]);
			P4[i]=p[4][i]+kr*(p[8][i]-p[4][i]);

			P5[i]=P1[i]+kb*(P2[i]-P1[i]);
			P6[i]=P3[i]+kb*(P4[i]-P3[i]);

			out[i]=P5[i]+kg*(P6[i]-P5[i]);
		}

/******************************************************SAVE*********************/
for(i=1;i<=3;++i){ if(out[i]>255)out[i]=255; if(out[i]<0)out[i]=0; }	/* R G B */

			fprintf(gridout,"%.3d %.3d %.3d\n",(int)out[1],(int)out[2],(int)out[3]);

}}}


}

fclose(dolby);
fclose(gridout);

/****************************************************************************/


}